[dpdk-ci] [PATCH v2 2/7] tools: add mail parser

Thomas Monjalon thomas.monjalon at 6wind.com
Thu Dec 1 14:44:47 CET 2016


This script get some mail headers from an email file.
The retrieved headers can be used for test and report in other scripts.

Signed-off-by: Thomas Monjalon <thomas.monjalon at 6wind.com>
---
 tools/parse-email.sh | 44 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 44 insertions(+)
 create mode 100755 tools/parse-email.sh

diff --git a/tools/parse-email.sh b/tools/parse-email.sh
new file mode 100755
index 0000000..2292773
--- /dev/null
+++ b/tools/parse-email.sh
@@ -0,0 +1,44 @@
+#! /bin/sh -e
+
+# This file is in the public domain.
+
+print_usage () {
+	cat <<- END_OF_HELP
+	usage: $(basename $0) <email_file>
+
+	Parse basic headers of the email
+	and print them as shell variable assignments to evaluate.
+	END_OF_HELP
+}
+
+while getopts h arg ; do
+	case $arg in
+		h ) print_usage ; exit 0 ;;
+		? ) print_usage >&2 ; exit 1 ;;
+	esac
+done
+shift $(($OPTIND - 1))
+if [ -z "$1" ] ; then
+	printf 'file argument is missing\n\n' >&2
+	print_usage >&2
+	exit 1
+fi
+
+getheader () # <header_name> <email_file>
+{
+	sed "/^$1: */!d;s///;N;s,\n[[:space:]]\+, ,;s,\n.*,,;q" "$2" |
+	sed 's,",\\",g'
+}
+
+subject=$(getheader Subject "$1")
+from=$(getheader From "$1")
+msgid=$(getheader Message-Id "$1")
+[ -n "$msgid" ] || msgid=$(getheader Message-ID "$1")
+listid=$(getheader List-Id "$1")
+
+cat <<- END_OF_HEADERS
+	subject="$subject"
+	from="$from"
+	msgid="$msgid"
+	listid="$listid"
+END_OF_HEADERS
-- 
2.7.0



More information about the ci mailing list